#include <stdio.h>

typedef struct {
	double re, im;
} Complex;

Complex makeComplex(double, double);
double realPart(Complex);
double imagPart(Complex);
Complex moinsComplex(Complex);
Complex addComplex(Complex, Complex);
Complex subComplex(Complex, Complex);
Complex mulComplex(Complex, Complex);
Complex divComplex(Complex, Complex);
double modComplex(Complex);
Complex conjComplex(Complex);
void affComplex(Complex);
int lireComplex(Complex *);


void main (void){
  Complex a,b,r;
  int saisie;
  char op;


	 do {
	  printf ("Entrez 2 nombres copmlexes et un operateur entre eux: ");
		saisie= lireComplex(&a);
		if (saisie){
			scanf("%c",&op);
			saisie= lireComplex(&b);
		}
		if(!saisie) fflush(stdin);
	 }while (!saisie);
  //Traitement
  switch (op){
	  case '+': r = addComplex(a,b); break;
	  case '-': r = subComplex(a,b); break;
	  case '*': r = mulComplex(a,b); break;
	  case '/': if (modComplex(b) !=0) r = divComplex(a,b);
					 else r = makeComplex(1e99,0); break;
	  default: r = makeComplex(-1e99,-1e99);
  }
  affComplex(a); printf("%c",op); affComplex(b); putchar('=');
  affComplex(r);

}

Complex makeComplex(double re, double im) {
  Complex r;
  r.re =re; r.im = im;
  return r;
}

double realPart(Complex c) {
  return c.re;
}

double imagPart(Complex c) {
  return c.im;
}

Complex moinsComplex(Complex c) {
  return makeComplex(-c.re,-c.im);
}

Complex addComplex(Complex a, Complex b) {
  return makeComplex(a.re+b.re,a.im+b.im);
}

Complex subComplex(Complex a, Complex b) {
  return addComplex(a, moinsComplex(b));
}

Complex mulComplex(Complex a, Complex b) {
  return makeComplex(a.re*b.re- a.im*b.im,a.im*b.re+a.re*b.im);
}

Complex divComplex(Complex a, Complex b) {
  double mod = modComplex(b);
  return makeComplex((a.re*b.re+a.im*b.im)/mod,(a.im*b.re-a.re*b.im)/mod);
}

double modComplex(Complex a){
  return a.re*a.re +a.im*a.im;
}

Complex conjComplex(Complex c){
	 return makeComplex(c.re,-c.im);

}

void affComplex(Complex c){
  printf("(%7.3lf+%7.3lfi)", c.re,c.im);
}
int lireComplex(Complex *c){
	int res;
	res = scanf("%lf+%lfi",&c->re,&c->im);
	return res == 2;
}
